unit LStep4X_Demo_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LStep4X, StdCtrls, Spin, ComCtrls, ExtCtrls;


type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit3: TEdit;
    Edit2: TEdit;
    Button5: TButton;
    InterfaceLS: TPageControl;
    ts_RS232: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    cbo_BaudRate: TComboBox;
    cbo_ComPort: TComboBox;
    ts_ISA: TTabSheet;
    Label3: TLabel;
    cbo_IOAddress: TComboBox;
    ts_PCI: TTabSheet;
    Label4: TLabel;
    sed_CardIndex: TSpinEdit;
    Panel2: TPanel;
    Button3: TButton;
    Button4: TButton;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Button6: TButton;
    InterfaceLS2: TPageControl;
    ts_RS232_2: TTabSheet;
    Label5: TLabel;
    Label6: TLabel;
    cbo_BaudRate2: TComboBox;
    cbo_ComPort2: TComboBox;
    ts_ISA2: TTabSheet;
    Label7: TLabel;
    cbo_IOAddress2: TComboBox;
    ts_PCI2: TTabSheet;
    Label8: TLabel;
    sed_CardIndex2: TSpinEdit;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    LStep1, LStep2: Integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var BCtrlInitPar: TLS_ControlInitPar;
begin
  LSX_SetWriteLogText(LStep1, True);

  FillChar(BCtrlInitPar, sizeof(TLS_ControlInitPar), 0);
  with BCtrlInitPar do
  begin
    Size := sizeof(TLS_ControlInitPar);
    ShowProt := True;

    if InterfaceLS.ActivePage = ts_RS232 then InterfaceType := 1;
    if InterfaceLS.ActivePage = ts_ISA then InterfaceType := 3;
    if InterfaceLS.ActivePage = ts_PCI then InterfaceType := 4;

    ComName := cbo_ComPort.Text;
    BaudRate := StrToInt(cbo_BaudRate.Text);

    case cbo_IOAddress.ItemIndex of
      0: IOAddress := $0280;
      1: IOAddress := $0300;
      2: IOAddress := $0340;
      3: IOAddress := $4280;
      4: IOAddress := $4300;
      5: IOAddress := $4340;
      6: IOAddress := $8280;
      7: IOAddress := $8300;
      8: IOAddress := $8340;
    end;

    CardIndex := sed_CardIndex.Value;

    ErrorCode := 0;
  end;

  LSX_ConnectEx(LStep1, BCtrlInitPar);

//  LSX_ConnectSimple(LStep1, 1, 'COM1', 57600, True);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  LSX_Disconnect(LStep1);
end;

procedure TForm1.Button3Click(Sender: TObject);
var BCtrlInitPar: TLS_ControlInitPar;
begin
  LSX_SetWriteLogText(LStep1, True);

  FillChar(BCtrlInitPar, sizeof(TLS_ControlInitPar), 0);
  with BCtrlInitPar do
  begin
    Size := sizeof(TLS_ControlInitPar);
    ShowProt := True;

    if InterfaceLS2.ActivePage = ts_RS232_2 then InterfaceType := 1;
    if InterfaceLS2.ActivePage = ts_ISA2 then InterfaceType := 3;
    if InterfaceLS2.ActivePage = ts_PCI2 then InterfaceType := 4;

    ComName := cbo_ComPort2.Text;
    BaudRate := StrToInt(cbo_BaudRate2.Text);

    case cbo_IOAddress2.ItemIndex of
      0: IOAddress := $0280;
      1: IOAddress := $0300;
      2: IOAddress := $0340;
      3: IOAddress := $4280;
      4: IOAddress := $4300;
      5: IOAddress := $4340;
      6: IOAddress := $8280;
      7: IOAddress := $8300;
      8: IOAddress := $8340;
    end;

    CardIndex := sed_CardIndex2.Value;

    ErrorCode := 0;
  end;

  LSX_ConnectEx(LStep2, BCtrlInitPar);

  //LSX_ConnectSimple(LStep2, 1, 'COM2', 9600, True);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  LSX_Disconnect(LStep2);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  LSX_MoveRel(LStep1, StrToFloat(Edit1.Text),
                 StrToFloat(Edit2.Text),
                 StrToFloat(Edit3.Text), 0, True);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  LSX_MoveRel(LStep2, StrToFloat(Edit4.Text),
                 StrToFloat(Edit5.Text),
                 StrToFloat(Edit6.Text), 0, True);
end;

procedure TForm1.Button7Click(Sender: TObject);
var Timeout: LongBool;
begin
  LSX_MoveRelSingleAxis(LStep1, 1, 60, false);
  Sleep(500);
  LSX_MoveRelSingleAxis(LStep1, 2, 50, false);
  LSX_WaitForAxisStop(LStep1, $03, 0, Timeout);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cbo_ComPort.ItemIndex := 0;
  cbo_BaudRate.ItemIndex := 3;
  cbo_ComPort2.ItemIndex := 0;
  cbo_BaudRate2.ItemIndex := 3;

  LSX_CreateLSID(LStep1);
  LSX_CreateLSID(LStep2);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  LSX_FreeLSID(LStep1);
  LSX_FreeLSID(LStep2);
end;

end.
